
#include "StdAfx.h"
#include "ZK_AI_Buffer.h"
#include <string.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ZK_AI_Buffer::ZK_AI_Buffer(HI_U32 dwSize, HI_BOOL bAutoDelete)
{
    m_bAutoDelete = bAutoDelete;
    ptr.b = new HI_U8[dwSize];
    m_u32ByteLen = dwSize;
}

ZK_AI_Buffer::ZK_AI_Buffer()
{
    m_bAutoDelete = HI_FALSE;
    ptr.b = NULL;
    m_u32ByteLen = 0;
}

ZK_AI_Buffer::ZK_AI_Buffer(HI_VOID *pBuffer, HI_U32 dwLength)
{
    m_bAutoDelete = HI_FALSE;
    ptr.b = NULL;
    m_u32ByteLen = 0;

    GetBuffer(pBuffer, dwLength);
}

ZK_AI_Buffer::~ZK_AI_Buffer()
{
    //
    if ((m_bAutoDelete) && (ptr.b != NULL))
    {
        delete[](ptr.b);
        ptr.b = NULL;
    }
}

//////////////////////////////////////////////////////////////////////////

HI_VOID ZK_AI_Buffer::Erase(HI_VOID)
{
    if (ptr.b)
    {
        memset(ptr.b, 0, m_u32ByteLen);
    }
}

//////////////////////////////////////////////////////////////////////////
/************************************************
* 	     : ZK_AI_GetUsedLength
*     	     : ȡĻС
*        : HI_S16 
*            : HI_VOID
*          : lizhaozao 
* ޶ʱ   : 2008-1-18 17:05:50
************************************************/

HI_S16 ZK_AI_Buffer::ZK_AI_GetUsedLength(HI_VOID)
{
    //ȡǰʹ
    return ptr.s[1] + 2;
}

//////////////////////////////////////////////////////////////////////////

HI_VOID ZK_AI_Buffer::GetBuffer(HI_VOID *pBuffer, HI_U32 dwLength)
{
    m_bAutoDelete = HI_FALSE;
    if (pBuffer)
    {
        ptr.v = pBuffer;
        m_u32ByteLen = dwLength;
    }
    else
    {
        ptr.b = NULL;
        m_u32ByteLen = 0;
    }
}

//////////////////////////////////////////////////////////////////////////
