#ifndef _ZK_NET_DEV_SDK_H_
#define _ZK_NET_DEV_SDK_H_

#include "hi_type.h"

#ifdef __cplusplus
#if __cplusplus
extern "C"{
#endif
#endif 

#ifdef HI_OS_LINUX
#define NETSDK_API
#define NETSDK_APICALL 
#else
#define NETSDK_API	__declspec(dllexport)
#define NETSDK_APICALL  __stdcall
#endif   

/* ־ */ 
#define HINET_IN
#define HINET_OUT

/* ַĳ */
#define ZK_NET_DEV_STR_LEN 64

/* 豸 ͨţĿǰ֧һͨ*/
#define ZK_NET_DEV_CHANNEL_1    1
//#define HI_NET_DEV_CHANNEL_2    2
//#define HI_NET_DEV_CHANNEL_3    3
//#define HI_NET_DEV_CHANNEL_4    4

/*  ģʽĿǰ֧TCP*/
#define ZK_NET_DEV_STREAM_MODE_TCP  0
//#define HI_NET_DEV_STREAM_MODE_UDP  1

/*ͣĿǰ֧ */
/*ֱ֧ݺ */
#define ZK_NET_DEV_STREAM_VIDEO_ONLY   0x01
#define ZK_NET_DEV_STREAM_AUDIO_ONLY   0x02
#define ZK_NET_DEV_STREAM_VIDEO_AUDIO 0x03
/*Ŀǰֽ֧䱨ݺ */
//#define HI_NET_DEV_STREAM_DATA_ONLY    0x04
#define ZK_NET_DEV_STREAM_VIDEO_DATA   0x05
#define ZK_NET_DEV_STREAM_AUDIO_DATA   0x06
#define ZK_NET_DEV_STREAM_ALL                  0x07

#define ZK_NET_DEV_VIDEO_AVI 0
#define ZK_NET_DEV_VIDEO_ASF 1
#define ZK_NET_DEV_VIDEO_264 2


/* ʼ */
typedef struct 
{
	HI_U32 u32Channel;      /*ͨ */
	HI_BOOL blFlag;            /*HI_TRUE:HI_FALSE:Ӵ*/
	HI_U32 u32Mode;         /*ģʽ*/
    HI_U8 u8Type;         /*ͣƵƵ*/
} HI_S_STREAM_INFO;

/* ¼ص*/
#define ZK_NET_DEV_CONNECTING                       0 /*  */
#define ZK_NET_DEV_CONNECTED                        1 /* ӳɹ */
#define ZK_NET_DEV_CONNECT_FAILED					2 /* ʧ */
#define ZK_NET_DEV_ABORTIBE_DISCONNECTED			3 /* ж */
#define ZK_NET_DEV_NORMAL_DISCONNECTED				4 /* Ͽ */
#define ZK_NET_DEV_RECONNECTING	                    5
#define ZK_NET_DEV_RECORD_START	                    6
#define ZK_NET_DEV_RECORD_STOP	                    7

typedef HI_S32 (*ZK_ON_EVENT_CALLBACK)(HI_U32 u32Handle, /*  */
                                HI_U32 u32Event,      /* ¼ */
                                HI_VOID* pUserData  /* û*/
                                );

/*ýݻص */
#define ZK_NET_DEV_AV_DATA   0	/* Ƶ */
#define ZK_NET_DEV_SYS_DATA  1  /* ϵͳ */

#define ZK_NET_DEV_VIDEO_FRAME_FLAG 0x46565848	/* Ƶ֡־ */
#define ZK_NET_DEV_AUDIO_FRAME_FLAG 0x46415848  /* Ƶ֡־ */

#define ZK_NET_DEV_VIDEO_FRAME_I    1 /* ؼ֡ */
#define ZK_NET_DEV_VIDEO_FRAME_P    2 /* ǹؼ֡ */
typedef struct 
{
    HI_U32 u32AVFrameFlag;               /* ֡־*/
    HI_U32 u32AVFrameLen;          /* ֡ĳ*/
    HI_U32 u32AVFramePTS;        /*ʱ */
    HI_U32 u32VFrameType;       /* ƵͣI֡P֡*/
} HI_S_AVFrame;

/* ϵͳͷ */
#define ZK_NET_DEV_SYS_FLAG 0x53565848
typedef struct
{
   HI_U32 u32Width;		/* Ƶ */
   HI_U32 u32Height;    /* Ƶ */
} HI_S_VideoHeader;

typedef struct
{
    HI_U32 u32Format;       /*Ƶʽ*/
} HI_S_AudioHeader;

typedef struct 
{
   HI_U32 u32SysFlag;
   HI_S_VideoHeader struVHeader;
   HI_S_AudioHeader struAHeader;
} HI_S_SysHeader;

typedef HI_S32 (*ZK_ON_STREAM_CALLBACK)(HI_U32 u32Handle, /*  */
                                HI_U32 u32DataType,     /* ͣϵͳݻƵ */
                                HI_U8*  pu8Buffer,      /* ݰ֡ͷ */
                                HI_U32 u32Length,      /* ݳ */
                                HI_VOID* pUserData    /* û*/
                                );

#define ZK_NET_DEV_MOTION_DETECTION	0	/* ƶ־ */
#define ZK_NET_DEV_INPUT_ALARM	 	1   /* ñ־ */
#define ZK_NET_DEV_KEEP_ALIVE		2   /* ݱ־ʱδ֧ */

/*ƶ */
#define ZK_NET_DEV_MOTION_AREA_MAX	4
#define ZK_NET_DEV_MOTION_AREA_1    1
#define ZK_NET_DEV_MOTION_AREA_2    2
#define ZK_NET_DEV_MOTION_AREA_3    3
#define ZK_NET_DEV_MOTION_AREA_4    4
typedef struct 
{
	HI_U32 u32Area;
	HI_U32 u32X;
	HI_U32 u32Y;
	HI_U32 u32Width;
	HI_U32 u32Height;
} HI_S_ALARM_MD;

typedef HI_S32 (*ZK_ON_DATA_CALLBACK)(HI_U32 u32Handle, /*  */
                                HI_U32 u32DataType,       /* */
                                HI_U8*  pu8Buffer,      /*  */
                                HI_U32 u32Length,      /* ݳ */
                                HI_VOID* pUserData    /* û*/
                                );

/* 豸 */
/* Product and Vendor */
typedef struct HI_ProductVendor
{
	HI_CHAR sProduct[32];	//ƷID
	HI_CHAR	sVendor[32];		//ID	
}HI_S_ProductVendor;

/* ͼչܣCMOSͷЧ*/
#define ZK_NET_DEV_SCENE_AUTO		0   /* Զģʽ */
#define ZK_NET_DEV_SCENE_INDOOR	1   /* ģʽ */
#define ZK_NET_DEV_SCENE_OUTDOOR	2   /* ģʽ */
typedef struct HI_Display_Ext
{
	HI_BOOL blFlip;         /* ·ת */
	HI_BOOL blMirror;     /* ҷת*/
	HI_S32 s32Scene;
} HI_S_Display_Ext;

/* ͼ */
typedef struct HI_Display
{
	HI_U32 u32Brightness;   /*    */
	HI_U32 u32Saturation;   /* Ͷ  */
	HI_U32 u32Contrast;     /*  Աȶ  */
	HI_U32 u32Hue;          /*  ɫ  */
} HI_S_Display;

typedef struct HI_Color
{
	HI_U32 u32Brightness;   /*    */
	HI_U32 u32Saturation;   /* Ͷ  */
	HI_U32 u32Contrast;     /*  Աȶ  */
	HI_U32 u32Hue;          /*  ɫ  */
	HI_U32 u32Shutter;      /*  */
	HI_U32 u32Dnt;			/*  */
	HI_U32 u32Lumivalue;	/*  */
} HI_S_Color;

/* ƿ */
#define ZK_NET_DEV_INFRARED_AUTO	       0    /* Զ */
#define ZK_NET_DEV_INFRARED_ON		1   /* ǿƿ */
#define ZK_NET_DEV_INFRARED_OFF		2   /* ǿƹر*/
typedef struct HI_Infrared
{
	HI_S32 s32Infrared;
} HI_S_Infrared;

/* Ƶ */
typedef struct HI_Video
{
	HI_U32 u32Channel;      /* ͨ */
       HI_BOOL blFlag;          /*   */
	HI_U32 u32Bitrate;	/*  */
	HI_U32 u32Frame;    /* ֡ */
	HI_U32 u32Iframe;	/* ֡1-300 */
	HI_BOOL blCbr;	    /* ģʽHI_TRUEΪ̶HI_FALSEΪɱ */		
	HI_U32 u32ImgQuality;	/* 1-6 */
} HI_S_Video;

/* ͼ */
#define ZK_NET_DEV_RESOLUTION_VGA		0
#define ZK_NET_DEV_RESOLUTION_QVGA		1
#define ZK_NET_DEV_RESOLUTION_QQVGA 	       2
#define ZK_NET_DEV_RESOLUTION_D1		       3
#define ZK_NET_DEV_RESOLUTION_CIF		       4
#define ZK_NET_DEV_RESOLUTION_QCIF		5
#define ZK_NET_DEV_RESOLUTION_720P		6
//#define HI_NET_DEV_RESOLUTION_1080P		7
typedef struct HI_Resolution
{
	HI_U32 u32Channel;      /* ͨ */
       HI_BOOL blFlag;            /*  HI_TRUE:HI_FALSE: */ 
	HI_U32 u32Resolution;
} HI_S_Resolution;

/* ƵʽƵ  */
typedef enum HI_Frequency
{
	FREQ_50HZ_PAL = 50,
	FREQ_60HZ_NTSC = 60
} HI_E_Frequency;

/* Ƶʽ */
#define ZK_NET_DEV_AUDIO_TYPE_G711		0 /* g711a */
#define ZK_NET_DEV_AUDIO_TYPE_G726		1
#define ZK_NET_DEV_AUDIO_TYPE_AMR		2 /* AMR NB 12.2kbps */
typedef struct HI_Audio
{
	HI_U32 u32Channel;              /* ͨ */
       HI_BOOL blFlag;                      /*־HI_TRUEΪHI_FALSEΪ*/
	HI_BOOL blEnable;               /* HI_TRUE:ƵHI_FALSE:رƵ  */
	HI_U32 u32Type;
} HI_S_Audio;

typedef enum HI_AudioInput
{
	AUDIO_INPUT_MIC = 100,	/*  */
	AUDIO_INPUT_LINE = 10  /*  */
} HI_E_AudioInput;

/* OSD */
typedef struct HI_OSD
{
	HI_BOOL blEnTime;	/* HI_TRUEʾʱOSDHI_FALSE ʾ */
	HI_BOOL blEnName;	/* HI_TRUEʾOSDHI_FALSE ʾ */
	HI_CHAR sName[64];	/* OSD */
} HI_S_OSD;

#define HI_OSD_TIME 0
#define HI_OSD_NAME 1
typedef struct HI_OSD_EX
{
	HI_U32 u32Area;		/**/
	HI_U32 u32X;
	HI_U32 u32Y;
} HI_S_OSD_EX;

typedef struct HI_MD_PARAM
{
       HI_U32 u32Channel;       /* ͨ */
	HI_U32 u32Area;            /*  */
       HI_BOOL blEnable;        /* HI_TRUEHI_FALSEرձ   */
       HI_U32 u32Sensitivity;  /* ȣȡֵΧ1~99 */
	HI_U32 u32X;
	HI_U32 u32Y;
	HI_U32 u32Width;
	HI_U32 u32Height;    
} HI_S_MD_PARAM;

#define ZK_NET_DEV_COVER_AREA_MAX  4
#define ZK_NET_DEV_COVER_AREA_1    1
#define ZK_NET_DEV_COVER_AREA_2    2
#define ZK_NET_DEV_COVER_AREA_3    3
#define ZK_NET_DEV_COVER_AREA_4    4

typedef struct HI_COVER_PARAM
{
	HI_U32 u32Area;            /* ڵ */
	HI_BOOL bShow;
	HI_U32 u32X;
	HI_U32 u32Y;
	HI_U32 u32Width;
	HI_U32 u32Height;    
	HI_U32 u32Color;
} HI_S_COVER_PARAM;

/* ̨*/
#define ZK_NET_DEV_PTZ_PRO_PELCOD	0
#define ZK_NET_DEV_PTZ_PRO_PELCOP	1
#define ZK_NET_DEV_PTZ_B110		110
#define ZK_NET_DEV_PTZ_B300		300
#define ZK_NET_DEV_PTZ_B1200		1200
#define ZK_NET_DEV_PTZ_B2400		2400
#define ZK_NET_DEV_PTZ_B4800		4800
#define ZK_NET_DEV_PTZ_B9600		9600
#define ZK_NET_DEV_PTZ_B19200		19200
#define ZK_NET_DEV_PTZ_B38400		38400
#define ZK_NET_DEV_PTZ_B57600		57600
#define ZK_NET_DEV_PTZ_STOP_1		1
#define ZK_NET_DEV_PTZ_STOP_2		2
#define ZK_NET_DEV_PTZ_DATA_5		5
#define ZK_NET_DEV_PTZ_DATA_6		6
#define ZK_NET_DEV_PTZ_DATA_7		7
#define ZK_NET_DEV_PTZ_DATA_8		8
#define ZK_NET_DEV_PTZ_PARITY_NONE	0
#define ZK_NET_DEV_PTZ_PARITY_ODD	       1
#define ZK_NET_DEV_PTZ_PARITY_EVEN	2
typedef struct HI_PTZ
{
	HI_U32 u32Protocol;     /* ̨Э  */
	HI_U32 u32Address;     /* ַ1-255 */ 
	HI_U32 u32Baud;          /* */
	HI_U32 u32DataBit;      /* ַλ*/     
	HI_U32 u32StopBit;      /* ֹͣλ*/
	HI_U32 u32Parity;       /* Уλ*/
} HI_S_PTZ;


#define SYSINFO_MAX_STRINGLENGTH (40)		// ϵͳϢ
#define SYSINFO_MAX_VERLENGTH (64)

typedef struct tagHI_NETINFO
{   
	HI_CHAR aszServerIP[SYSINFO_MAX_STRINGLENGTH];       /*IPַ*/
	HI_CHAR aszNetMask[SYSINFO_MAX_STRINGLENGTH];        /**/
	HI_CHAR aszGateWay[SYSINFO_MAX_STRINGLENGTH];        /**/
	HI_CHAR aszMacAddr[SYSINFO_MAX_STRINGLENGTH];        /*MAC ַ*/
	HI_CHAR aszFDNSIP[SYSINFO_MAX_STRINGLENGTH];         /*first DNSIP*/
	HI_CHAR aszSDNSIP[SYSINFO_MAX_STRINGLENGTH];         /*DNSIP*/
	HI_S32  s32DhcpFlag;                                 /*DHCP*/
	HI_S32  s32DnsDynFlag;                               /*DNS ̬ʶ*/
}HI_S_NETINFO, *PHI_S_NETINFO;

// 豸Ϣ
typedef struct tagHI_DEVICE_INFO
{   
    HI_CHAR aszServerSerialNumber[SYSINFO_MAX_STRINGLENGTH + 1];	/*豸к*/
	//HI_CHAR aszServerHardVersion[SYSINFO_MAX_VERLENGTH + 1];		/*Ӳ汾*/
    HI_CHAR aszServerSoftVersion[SYSINFO_MAX_VERLENGTH + 1];		/*汾*/
    HI_CHAR aszServerName[SYSINFO_MAX_STRINGLENGTH + 1];			/**/
    HI_CHAR aszServerModel[SYSINFO_MAX_STRINGLENGTH + 1];			/*ͺ*/
    HI_CHAR aszStartDate[SYSINFO_MAX_STRINGLENGTH + 1];				/*ϵͳʱ*/
	//HI_CHAR aszTimes[SYSINFO_MAX_STRINGLENGTH + 1];				/*ϵͳʱ,λ:.uptime*/
	//HI_CHAR aszServerInterface[48 + 1];							/*ӿͺ*/ //fengjf
	HI_S32 s32ConnectState;											/*״̬*/
}HI_DEVICE_INFO, *PHI_DEVICE_INFO;

typedef struct tagHI_SYSDEVICE{
	HI_S_NETINFO netInfo;			/*Ϣ*/
	HI_DEVICE_INFO deviceInfo;		/*豸Ϣ*/
}HI_S_SYSDEVICE;


typedef HI_S32 (*OnUpgradeCallBack)(HI_U32 u32Chn, HI_S32 s32Persent, HI_VOID *pUserData);


typedef struct hiUPGRADE_INFO_S
{
	HI_CHAR sHost[32];
	HI_U32  u32Port;
	HI_CHAR sUser[16];
	HI_CHAR sPass[16];
	HI_CHAR sPath[256];
	HI_U32  u32Chn;
	HI_VOID *pUserData;
	OnUpgradeCallBack callBack;
}UPGRADE_INFO_S;


typedef struct HI_HTTPPORT
{
	HI_U32 u32HttpPort;
} HI_S_HTTPPORT;

typedef struct hiSERVERTIME_INFO_S
{
	HI_CHAR sTime[32];
} HI_S_SERVERTIME;

typedef struct HI_NET_EXT
{
	HI_S_NETINFO  sNetInfo;
	HI_S_HTTPPORT sHttpPort;
}HI_S_NET_EXT;

typedef struct HI_ATTR_EXT
{
	HI_U32  u32Enable;
	HI_U32  u32Flag;
}HI_S_ATTR_EXT;

typedef struct HI_WIFI_PARAM
{
	HI_CHAR sSsID[32];
	HI_CHAR sKey[32];
	HI_U32 u32Enable;
	HI_U32 u32Auth;
	HI_U32 u32Enc;
	HI_U32 u32Mode;
}HI_S_WIFI_PARAM;

typedef struct HI_WFPT
{
	HI_U32 u32Chn;
	HI_S32 s32Rssi;
	HI_CHAR sSsID[32];
	HI_CHAR sMac[20];
	HI_CHAR sEnc[32];
	HI_CHAR sAuth[32];
	HI_CHAR sNet[32];
}HI_S_WFPT;

#define MAX_WFPT 64
typedef struct HI_WIFI_INFO
{
	HI_U32 u32Num;
	HI_S_WFPT sWfPt[MAX_WFPT];
}HI_S_WIFI_INFO;

typedef struct HI_OUR_DNS
{
	HI_CHAR sServer[32];
	HI_CHAR sUsername[32];
	HI_CHAR sPassword[32];
	HI_U32  u32Enable;
	HI_U32	u32Port;
	HI_CHAR sDomain[32];
}HI_S_OUR_DNS;

typedef struct hiDEVID
{
	HI_CHAR sDevID[32];
}HI_S_DEVID;

typedef struct hiIMAGE
{
	HI_U32 u32Brightness;   //
	HI_U32 u32Saturation;   //Ͷ
	HI_U32 u32Contrast;     //Աȶ
	HI_U32 u32Hue;          //ɫ
	HI_U32 u32Shutter;		//
	HI_U32 u32Dnt;			//ɫ
	HI_U32 u32Lumivalue;	//ն
	HI_U32 u32Sensor;		// 1--9d1312--2643 
	HI_BOOL bFlip;			//·ת
	HI_BOOL bMirror;		//ҷת
	HI_BOOL bNight;			//ҹģʽ
	HI_BOOL bWdr;			//̬
	HI_BOOL bLumiswitch;	//նȿ
} HI_S_IMAGE;

/*  */
#define ZK_NET_DEV_GET_PRODUCT_VENDOR			0x1000
#define ZK_NET_DEV_CMD_DISPLAY					0x1001
#define ZK_NET_DEV_CMD_DISPLAY_EXT				0x1002
#define ZK_NET_DEV_CMD_INFRARED					0x1003
#define ZK_NET_DEV_CMD_VIDEO_PARAM				0x1004
#define ZK_NET_DEV_CMD_OSD_PARAM				0x1005
#define ZK_NET_DEV_CMD_AUDIO_PARAM				0x1006
#define ZK_NET_DEV_CMD_AUDIO_INPUT				0x1007
#define ZK_NET_DEV_CMD_RESOLUTION				0x1008
#define ZK_NET_DEV_CMD_FREQUENCY				0x1009
#define ZK_NET_DEV_CMD_PTZ_PARAM				0x1010
#define ZK_NET_DEV_CMD_MD_PARAM				    0x1011
#define ZK_NET_DEV_CMD_NET_INFO					0x1012
#define ZK_NET_DEV_CMD_HTTP_PORT				0x1013
#define ZK_NET_DEV_CMD_DEVICE_INFO				0x1014
#define ZK_NET_DEV_CMD_PRODUCTID				0x1015
#define ZK_NET_DEV_CMD_USERNUM					0x1016
#define ZK_NET_DEV_CMD_SERVER_TIME				0x1017
#define ZK_NET_DEV_CMD_REBOOT					0x1018
#define ZK_NET_DEV_CMD_RESET					0x1019
#define ZK_NET_DEV_CMD_NET_EXT					0x1022
#define ZK_NET_DEV_CMD_ATTR_EXT					0x1026
#define ZK_NET_DEV_CMD_WIFI_PARAM				0x1030
#define ZK_NET_DEV_CMD_WIFI_SEARCH				0x1031

#define ZK_NET_DEV_CMD_COLOR					0x1040
#define ZK_NET_DEV_CMD_DEVID					0x1042
#define ZK_NET_DEV_CMD_IMAGE_DEFAULT			0x1043
#define ZK_NET_DEV_CMD_OUR_DNS					0x1044

#define ZK_NET_DEV_CMD_BUT						0x1064

/* ̨ƶ */
#define ZK_NET_DEV_CTRL_PTZ_STOP			0x3000
#define ZK_NET_DEV_CTRL_PTZ_UP			0x3001
#define ZK_NET_DEV_CTRL_PTZ_DOWN			0x3002
#define ZK_NET_DEV_CTRL_PTZ_LEFT			0x3003
#define ZK_NET_DEV_CTRL_PTZ_RIGHT			0x3004
#define ZK_NET_DEV_CTRL_PTZ_ZOOMIN		0x3005
#define ZK_NET_DEV_CTRL_PTZ_ZOOMOUT		0x3006

#define ZK_NET_DEV_CTRL_PTZ_FOCUSIN			0x3007
#define ZK_NET_DEV_CTRL_PTZ_FOCUSOUT		0x3008
#define ZK_NET_DEV_CTRL_PTZ_APERTUREIN		0x3009
#define ZK_NET_DEV_CTRL_PTZ_APERTUREOUT		0x3010

#define ZK_NET_DEV_CTRL_PTZ_GOTO_PRESET	0x3015
#define ZK_NET_DEV_CTRL_PTZ_SET_PRESET	0x3016
#define ZK_NET_DEV_CTRL_PTZ_CLE_PRESET	0x3017

#define ZK_NET_DEV_CTRL_PTZ_LIGHT_ON	0x3021
#define ZK_NET_DEV_CTRL_PTZ_LIGHT_OFF	0x3022
#define ZK_NET_DEV_CTRL_PTZ_WIPER_ON	0x3023
#define ZK_NET_DEV_CTRL_PTZ_WIPER_OFF	0x3024
#define ZK_NET_DEV_CTRL_PTZ_AUTO_ON		0x3025
#define ZK_NET_DEV_CTRL_PTZ_AUTO_OFF	0x3026
#define ZK_NET_DEV_CTRL_PTZ_HOME		0x3027
#define ZK_NET_DEV_CTRL_PTZ_CRUISE_V	0x3028
#define ZK_NET_DEV_CTRL_PTZ_CRUISE_H	0x3029

#define ZK_NET_DEV_CTRL_PTZ_TRAN	0x4000

#define ZK_NET_DEV_CTRL_PTZ_SPEED_MAX	0x3F
#define ZK_NET_DEV_CTRL_PTZ_SPEED_MIN	0x00
#define ZK_NET_DEV_CTRL_PTZ_PRESET_MAX	255
#define ZK_NET_DEV_CTRL_PTZ_PRESET_MIN	0
#define ZK_NET_DEV_CTRL_PTZ_FT_BUF_LEN	64

#define ZK_NET_DEV_SNAP_BUF_LEN_MIN		1024

/*  */
/* ʼȥʼֻһ  */
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_Init();
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_DeInit();
/*  û¼ */
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_Login(HINET_OUT HI_U32* pu32Handle, const HI_CHAR* psUsername, const HI_CHAR* psPassword, const HI_CHAR* psHost, HI_U16 u16Port);
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_LoginExt(HINET_OUT HI_U32* pu32Handle, const HI_CHAR* psUsername, const HI_CHAR* psPassword, const HI_CHAR* psHost, HI_U16 u16Port, HI_U32 u32TimeOut=10000);
/* ûǳ*/
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_Logout(HI_U32 u32Handle);
/* ӳʱʱ䣬Ĭϳʱ5룬λǺ*/
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_SetConnectTimeout(HI_U32 u32Handle, HI_U32 u32Timeout);
/* Զʱ䣬ĬΪ10룬0ΪλǺ */
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_SetReconnect(HI_U32 u32Handle, HI_U32 u32Interval);
/* ʼ */
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_StartStream(HI_U32 u32Handle, HI_S_STREAM_INFO*  pstruStreamInfo);
/* ֹͣ  */
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_StopStream(HI_U32 u32Handle);
/* ¼ص  */
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_SetEventCallBack(HI_U32 u32Handle, ZK_ON_EVENT_CALLBACK cbEventCallBack, HI_VOID* pUserData);
/* Ƶݻص  */
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_SetStreamCallBack(HI_U32 u32Handle, ZK_ON_STREAM_CALLBACK cbStreamCallBack, HI_VOID* pUserData);
/* ñݻص  */
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_SetDataCallBack(HI_U32 u32Handle, ZK_ON_DATA_CALLBACK cbDataCallBack, HI_VOID* pUserData);
/* úͻȡ */
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_SetConfig(HI_U32 u32Handle, HI_U32 u32Command, HI_VOID* pBuf, HI_U32 u32BufLen);
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_GetConfig(HI_U32 u32Handle, HI_U32 u32Command, HINET_OUT HI_VOID* pBuf, HI_U32 u32BufLen);
/* ̨*/
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_PTZ_Ctrl_Standard(HI_U32 u32Handle, HI_U32 u32Command, HI_U32 u32Speed);
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_PTZ_Ctrl_StandardEx(HI_U32 u32Handle, HI_U32 u32Command);
/* ̨Ԥλ */
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_PTZ_Ctrl_Preset(HI_U32 u32Handle, HI_U32 u32Command, HI_U32 u32Preset);
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_PTZ_Ctrl_Extend(HI_U32 u32Handle, HI_U32 u32Command);
/* ̨͸  */
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_PTZ_Fully_Trans(HI_U32 u32Handle, const HI_CHAR* psBuf, HI_U32 u32BufLen);
/* Խ */
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_StartVoice(HI_U32 u32Handle, HI_U32 u32AudioType);
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_StopVoice(HI_U32 u32Handle);
/* ݣG.726  */
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_SendVoiceData(HI_U32 u32Handle, HI_CHAR* psBuf, HI_U32 u32BufLen, HI_U64 u64Pts);
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_SnapJpeg(HI_U32 u32Handle, HI_U8* pu8Data, HI_S32 s32BufLen, HI_S32 *pSize);

NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_StartRecord(HI_U32 u32Handle, HI_CHAR* psPath, HI_U32 u32Type, HI_U32 u32Flag);
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_StopRecord(HI_U32 u32Handle);
NETSDK_API HI_S32 NETSDK_APICALL ZK_NET_DEV_GetRecordState(HI_U32 u32Handle);

#ifdef __cplusplus
#if __cplusplus
}
#endif
#endif

#endif

